/***************************************************************************
                          clineeditdlg.cpp  -  description
                             -------------------
    begin                : Mon Jul 17 2000
    copyright            : (C) Ives Development Inc, 2000
    email                : Mark_Dixon@teamstudio.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <kapp.h>
#include <kmsgbox.h>
#include "clineeditdlg.h"

CLineEditDlg::CLineEditDlg(const char* pcszPrompt, const char* pcszDefault,
	QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();

	m_staticPrompt->setText( pcszPrompt );
	m_edit->setText( pcszDefault );

	connect( m_buttonOK, SIGNAL( clicked() ), SLOT( slotOnOK() ) );
	connect( m_buttonCancel, SIGNAL( clicked() ), SLOT( reject() ) );
}

CLineEditDlg::~CLineEditDlg(){
}

QString CLineEditDlg::getText()
{
	return m_edit->text();
}

void CLineEditDlg::slotOnOK()
{
	QString strRaw( m_edit->text() );
	QString strNeat = strRaw.simplifyWhiteSpace();
	if ( !strNeat.isEmpty() ){
		m_edit->setText( strNeat );
		accept();
	}
	else{
		KMsgBox::message( this, 0, i18n( "You must supply a value" ) );
		m_edit->setFocus();
	}
}