/***************************************************************************
                          cmapdlg.cpp  -  description
                             -------------------
    begin                : Thu Jul 6 2000
    copyright            : (C) Ives Development Inc, 2000
    email                : Mark_Dixon@teamstudio.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <kapp.h>
#include <kmsgbox.h>
#include "cmapdlg.h"

CMapDlg::CMapDlg(QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
	//	Load up the combo with the list of servers
	KConfig* config = kapp->getConfig();
	config->setGroup( "Mapping" );
	int i = 0;
	char szName[ 15 ];
	sprintf( szName, "Map%i", i );
	QListViewItem* pitem = 0;
	QStrList lststr;
	while ( config->readListEntry( szName, lststr ) ){
		if ( 0 == strcmp( lststr.at( 0 ), "" ) ){
			break;
		}
		if ( 0 == pitem || 0 != strcmp( pitem->text( 0 ), lststr.at( 0 ) ) ){
			pitem = new QListViewItem( m_listMaps, lststr.at( 0 ) );
		}
		new QListViewItem( pitem, lststr.at( 1 ), lststr.at( 2 ), lststr.at( 3 ) );
		++i;
		sprintf( szName, "Map%i", i );
	}
	connect( m_buttonOK, SIGNAL( clicked() ), SLOT( slotOnOK() ) );
	connect( m_buttonCancel, SIGNAL( clicked()) , SLOT( reject() ) );
	connect( m_buttonAdd, SIGNAL( clicked() ), SLOT( slotOnAdd() ) );
	connect( m_buttonRemove, SIGNAL( clicked() ), SLOT( slotOnRemove() ) );
	connect( m_listMaps, SIGNAL( selectionChanged( QListViewItem* ) ),
		SLOT( slotLVSelChanged( QListViewItem* ) ) );
	m_buttonRemove->setEnabled( false );
	if ( 0 != m_listMaps->childCount() ){
		m_listMaps->setCurrentItem( m_listMaps->firstChild() );
	}
}

CMapDlg::~CMapDlg(){
}

QListViewItem* CMapDlg::nextItem( QListViewItem* pitem )
{
	if ( NULL !=  pitem->firstChild() ){
		return pitem->firstChild();
	}
	while ( NULL != pitem ){
		if ( NULL != pitem->nextSibling() ){
			return pitem->nextSibling();
		}
		pitem = pitem->parent();
	}
	return NULL;
}

void CMapDlg::slotOnOK()
{
	//	Save the data...
	KConfig* config = kapp->getConfig();
	config->setGroup( "Mapping" );
	int i = 0;
	char szName[ 15 ];
	sprintf( szName, "Map%i", i );
	QListViewItem* pitem = m_listMaps->firstChild();
	QString strServer;
	while ( 0 != pitem ){
		if ( 0 == pitem->parent() ){
			strServer = pitem->text( 0 );
		}
		else{
			QStrList lststr;
			lststr.append( strServer );
			lststr.append( pitem->text( 0 ) );
			lststr.append( pitem->text( 1 ) );
			lststr.append( pitem->text( 2 ) );
			config->writeEntry( szName, lststr );
			++i;
			sprintf( szName, "Map%i", i );
		}
		pitem = nextItem( pitem );
	}
	//	Write a terminator entry.  Not too elegant, but KConfig doesn't have a 'deleteEntry'.
	config->writeEntry( szName, "" );

	accept();
}

void CMapDlg::slotOnRemove()
{
	if ( 0 == m_listMaps->currentItem() ){
		return;
	}
	if ( 0 == m_listMaps->currentItem()->parent() ){
		if ( 1 !=	KMsgBox::yesNo( this, 0, i18n( "This will delete all mappings for this server. Continue?" ) ) ){
			return;
		}
	}
	delete m_listMaps->currentItem();
	m_buttonRemove->setEnabled( 0 != m_listMaps->currentItem() );
}

void CMapDlg::slotOnAdd()
{
	if ( 0 == strlen( m_editServer->text() ) ){
		KMsgBox::message( this, 0, ( i18n( "You must specify a server for the mapping" ) ) );
		m_editServer->setFocus();
		return;
	}
	if ( 0 == strlen( m_editLocal->text() ) ){
		KMsgBox::message( this, 0, ( i18n( "You need to supply a local path to create a mapping" ) ) );
		m_editLocal->setFocus();
		return;
	}
	if ( 0 == strlen( m_editServerPath->text() ) ){
		KMsgBox::message( this, 0, ( i18n( "You need to supply a server path to create a mapping" ) ) );
		m_editServerPath->setFocus();
		return;
	}
	if ( 0 == strlen( m_editBrowser->text() ) ){
		KMsgBox::message( this, 0, ( i18n( "You need to supply a browser path to create a mapping" ) ) );
		m_editBrowser->setFocus();
		return;
	}
	QListViewItem* pitem = m_listMaps->firstChild();
	while ( NULL != pitem ){
		if ( 0 == strcmp( pitem->text( 0 ), m_editServer->text() ) ){
			break;
		}
    pitem = nextItem( pitem );
	}
	if ( NULL == pitem ){
		pitem = new QListViewItem( m_listMaps, m_editServer->text() );
	}
	QListViewItem* pitemNew = new QListViewItem( pitem, m_editLocal->text(), m_editServerPath->text(),
		m_editBrowser->text() );
	m_listMaps->setOpen( pitem, true );
	m_listMaps->setCurrentItem( pitemNew );
	m_buttonRemove->setEnabled( true );
}

void CMapDlg::slotLVSelChanged( QListViewItem* pitem )
{
	if ( 0 != pitem->parent() ){
		m_editServer->setText( pitem->parent()->text( 0 ) );
		m_editLocal->setText( pitem->text( 0 ) );
		m_editServerPath->setText( pitem->text( 1 ) );
		m_editBrowser->setText( pitem->text( 2 ) );
	}
	else{
		m_editServer->setText( pitem->text( 0 ) );
		m_editLocal->clear();
		m_editServerPath->clear();
		m_editBrowser->clear();
	}
}
