/***************************************************************************
                          dbgr.h  -  description
                             -------------------
    begin                : Mon Jun 5 2000
    copyright            : (C) Ives Development Inc, 2000
    email                : Mark_Dixon@teamstudio.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "designer.h"

//	Abstract Base class for PHP, perl etc debuggers
class CDebugger : public QObject
{
	Q_OBJECT

public:
	CDebugger(  DesignerApp* papp );
	virtual ~CDebugger();

//	common debugger operations
	virtual	QString EscapeExpr( const char* pcsz ) = 0;
	virtual QString UnEscapeExpr( const char* pcsz ) = 0;

	virtual	int		fIsActive() = 0;
	virtual	void	Activate() = 0;
	virtual	void	Go() = 0;
	virtual	void	StepInto() = 0;
	virtual	void	StepOver() = 0;
	virtual	void	Stop() = 0;
	virtual	void	OnWatchListChanged() = 0;

	virtual	int		curLine() = 0;

protected:
	DesignerApp*	m_papp;
};
