/***************************************************************************
                          designer.h  -  description
                             -------------------
    begin                : Wed May 24 16:16:04 EDT 2000
    copyright            : (C) Ives Development Inc, 2000
    email                : Mark_Dixon@teamstudio.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DESIGNERDOC_H
#define DESIGNERDOC_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for QT
#include <qobject.h>
#include <qstring.h>
#include <qlist.h>
#include <qdict.h>
#include <qstrlist.h>
#include <qpopupmenu.h>

// forward declaration of the Designer classes
class DesignerView;
class KWrite;

/**	DesignerDoc provides a document object for a document-view model.
  *
  * The DesignerDoc class provides a document object that can be used in conjunction with the classes DesignerApp and DesignerView
  * to create a document-view model for standard KDE applications based on KApplication and KTMainWindow. Thereby, the document object
  * is created by the DesignerApp instance and contains the document structure with the according methods for manipulation of the document
  * data by DesignerView objects. Also, DesignerDoc contains the methods for serialization of the document data from and to files.
  *
  * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team. 	
  * @version KDevelop version 0.4 code generation
  */
class DesignerDoc : public QObject
{
  Q_OBJECT
  public:
    /** Constructor for the fileclass of the application */
    DesignerDoc(QWidget *parent, const char *name=0);
    /** Destructor for the fileclass of the application */
    ~DesignerDoc();

    /** adds a view to the document which represents the document contents. Usually this is your main view. */
    void addView(DesignerView *view);
    /** removes a view from the list of currently connected views */
    void removeView(DesignerView *view);
    /** sets the modified flag for the document after a modifying action on the view connected to the document.*/
    void setModified(bool _m=true);
    /** returns if the document is modified or not. Use this to determine if your document needs saving by the user on closing.*/
    bool isModified();
    /** "save modified" - asks the user for saving if the document is modified */
    bool saveModified();	
    /** deletes the document's contents */
    void deleteContents();
    /** initializes the document generally */
    bool newDocument( const char *filename = 0 );
    /** closes the acutal document */
    void closeDocument();
    /** loads the document by filename and format and emits the updateViews() signal */
    bool openDocument(const QString &filename, const char *format=0);
    /** saves the document under filename and format.*/	
    bool saveDocument(const QString &filename, const char *format=0);
    /** sets the path to the file connected with the document */
    void setAbsFilePath(const QString &filename);
    /** returns the pathname of the current document file*/
    QString getAbsFilePath() const;
    /** sets the filename of the document */
    void setTitle(const QString &_t);
    /** returns the title of the document */
    const QString &getTitle();
		
		QString getBreakpoints( const char* pcszFileName );

		KWrite* newWrite(QWidget *parent);
		void setStepLine( int iLIne );	

  public slots:
    /** calls repaint() on all views connected to the document object and is called by the view by which the document has been changed.
     * As this view normally repaints itself, it is excluded from the paintEvent.
     */
    void slotUpdateAllViews(DesignerView *sender);
 		void slotOnShowRBMenu( void );
		void slotEditCurrentTag( void );

		void selectWrite( int );
		void setWriteMode( int );
		void updateViewMenu( QPopupMenu* );

	signals:
		void	notifyBPChange( const QString&, int iLine );

  public:	
    /** the list of the views currently connected to the document */
    static QList<DesignerView> *pViewList;	
    KWrite*	write;	//	The currently displayed write

  private:
		QString	GetCurrentTag();
		void changeFileName(QString newname);
		bool saveAll(bool type=true);
		bool isModifiedAll();



    QString title;
		QDict<int>* fileList;
		DesignerView*	view;
		QStrList* fileNameList;
		QPopupMenu* writeRBMenu;
};

#endif // DESIGNERDOC_H
