/***************************************************************************
                          designerview.h  -  description
                             -------------------
    begin                : Wed May 24 16:16:04 EDT 2000
    copyright            : (C) Ives Development Inc, 2000
    email                : Mark_Dixon@teamstudio.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DESIGNERVIEW_H
#define DESIGNERVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>
#include <qlayout.h>
#include <qwidgetstack.h>

#include "filetabbar.h"

class DesignerDoc;
class KWrite;

/** The DesignerView class provides the view widget for the DesignerApp instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As DesignerView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the DesignerApp class to manipulate and display
 * the document structure provided by the DesignerDoc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class DesignerView : public QWidget
{
	friend class DesignerDoc;

  Q_OBJECT
  public:
    /** Constructor for the main view */
    DesignerView(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~DesignerView();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a DesignerApp instance as a parent
     * widget to get to the window document pointer by calling the DesignerApp::getDocument() method.
     *
     * @see DesignerApp#getDocument
     */
    DesignerDoc *getDocument() const;

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);
	
	protected slots:
  void selectWrite(int id);
	void slotNewCurPos();

	signals: // Signals
  /**  */
  void newCurPos();
  /** emit when select document from tabbar */
  void writeSelected(int);

	public:
	int addWrite( KWrite *w , char *label );
	KWrite* write();
	KWrite* removeWrite();
	KWrite* write(int id);
  FileTabBar* 	fileTabBar;

	protected:
  QVBoxLayout*	topLayout;
  QWidgetStack* writeStack;
	
	
};

#endif // DESIGNERVIEW_H
