/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Wed May 24 16:16:04 EDT 2000
    copyright            : (C) Ives Development Inc, 2000
    email                : Mark_Dixon@teamstudio.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "designer.h"

DesignerApp* gpMainFrame;

CAppWithIdle::CAppWithIdle( int argc, char* argv[], const char* pszApp, const char* pszHelpDir ) :
	KApplication( argc, argv, pszApp ), m_strHelpDir( pszHelpDir )
{
}

CAppWithIdle::~CAppWithIdle()
{
}

bool CAppWithIdle::notify( QObject* pobj, QEvent* pev )
{
	if ( !KApplication::notify( pobj, pev ) ){
		return false;
	}
	switch ( pev->type() ){
	case Event_MouseMove:
	case Event_Move:
	case Event_Paint:
		;
		break;
	default:
    emit UpdateCommands();
	}
	return true;
}

void CAppWithIdle::appHelpActivated()
{
  invokeHTMLHelp( m_strHelpDir + "/" + "index.html", "" );
}

int main(int argc, char *argv[])
{
  CAppWithIdle app(argc, argv, "Nexidion Designer", "designer" );
 
  if (app.isRestored())
  {
    RESTORE(DesignerApp);
  }
  else 
  {
		gpMainFrame = 0;
    new DesignerApp();	//	sets gpMainFrame

    gpMainFrame->show();

    if(argc>1)
    {
      gpMainFrame->openDocumentFile(argv[1]);
    }
  }

  return app.exec();
}  
