/***************************************************************************
                          outwnd.cpp  -  description
                             -------------------
    begin                : Fri Jun 2 2000
    copyright            : (C) Ives Development Inc, 2000
    email                : Mark_Dixon@teamstudio.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <kapp.h>

#include "outwnd.h"

COutputWnd::COutputWnd( QWidget* parent, const char* name ) :
	CTabCtl( parent, name )
{
	setShape( QTabBar::TriangularBelow );
	for ( int i = 0 ; i < 3 ; ++i ){
		m_wndTab[ i ] = new QMultiLineEdit( this );
		m_wndTab[ i ]->setReadOnly( TRUE );
	}
	addTab( m_wndTab[ 0 ], "stdout" );
	addTab( m_wndTab[ 1 ], "stderr" );
	addTab( m_wndTab[ 2 ], i18n( "transcript" ) );
}

void	COutputWnd::Clear()
{
	m_wndTab[ 0 ]->setText( "" );
	m_wndTab[ 1 ]->setText( "" );
	m_wndTab[ 2 ]->setText( "" );
}

void	COutputWnd::Append( enum owType type, const char* pcsz )
{
	int Line = m_wndTab[ type ]->numLines();
	int Col = 0xFFFF;
	m_wndTab[ type ]->setCursorPosition( Line, Col );
	m_wndTab[ type ]->cursorPosition( &Line, &Col );
	m_wndTab[ type ]->insertAt( pcsz, Line, Col );
}
