/***************************************************************************
                          phpdbgr.h  -  description
                             -------------------
    begin                : Mon Jun 5 2000
    copyright            : (C) Ives Development Inc, 2000
    email                : Mark_Dixon@teamstudio.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qsocketnotifier.h>
#include <kprocess.h>
#include "dbgr.h"

class CPHPDebugger : public CDebugger
{
	Q_OBJECT

public:
	CPHPDebugger(  DesignerApp* papp );
	virtual ~CPHPDebugger();

//	common debugger operations
	QString EscapeExpr( const char* pcsz );
	QString UnEscapeExpr( const char* pcsz );

	int		fIsActive();
	void	Activate();
	void	Go();
	void	StepInto();
	void	StepOver();
	void	Stop();
	void	OnWatchListChanged();

	int		curLine();

public slots:
	void	slotOnBPChange( const QString& pcszFile );
	void	slotOnWatchListChange();

//	Implementation
protected slots:
	void	OnDataReady( void );
	void	OnConnectReady( void );
	void  OnProcessExited( KProcess* proc );

protected:
	void		SendLine( const char* pcsz );
	QString	ReadLine();

	void		AddVar( const char* pcszLine, int i );
	void		UpdateState();	
	void		SendBreakpoints();

	int			m_sockSession;
	int			m_sockSvr;
	QSocketNotifier*	m_psnSvr;
	QSocketNotifier*	m_psnSession;

	char	m_acBuffer[ 1024 ];
	int		m_cbBuf;

	enum { INACTIVE, LISTENING, READY, BUSY }	m_state;

	QString m_strServer;
	QString m_strFile;
	QString	m_strFileId;

	int		m_line;
};
