/***************************************************************************
                          varwnd.cpp  -  description
                             -------------------
    begin                : Thu Jun 1 2000
    copyright            : (C) Ives Development Inc, 2000
    email                : Mark_Dixon@teamstudio.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kapp.h>	//	for i18n
#include <assert.h>

#include "varwnd.h"

CVariablesWnd::CVariablesWnd( QWidget* parent, const char* name ) :
	CTabCtl( parent, name )
{
	setShape( QTabBar::TriangularBelow );
	for ( int i = 0 ; i < 3 ; ++i ){
		m_wndTab[ i ] = new QListView( this );
		m_wndTab[ i ]->addColumn( "Name", 75 );
		m_wndTab[ i ]->addColumn( "Value" );
		m_wndTab[ i ]->setAllColumnsShowFocus( TRUE );
		m_wndTab[ i ]->setSorting( -1 );
	}
	addTab( m_wndTab[ 0 ], i18n( "Auto" ) );
	addTab( m_wndTab[ 1 ], i18n( "Locals" ) );
	addTab( m_wndTab[ 2 ], "this" );
}

class CVarListItem : public QListViewItem
{
public:
	CVarListItem( const char* pcszText, CVarListItem* pitemParent, CVarListItem* pitemPrev );
	CVarListItem( const char* pcszText, CVarListItem* pitemParent );
	CVarListItem( const char* pcszText, QListView* plv );

	int	m_extra;
};
/*
CVarListItem::CVarListItem( const char* pcszText, CVarListItem* pitemParent, CVarListItem* pitemPrev ) :
	QListViewItem(pitemParent, pitemPrev, pcszText )
{
}

CVarListItem::CVarListItem( const char* pcszText, CVarListItem* pitemParent ) :
	QListViewItem( pitemParent, pcszText )
{
}

CVarListItem::CVarListItem( const char* pcszText, QListView* plv ) :
	QListViewItem( plv, pcszText )
{
}
*/
CVarListItem* CVariablesWnd::firstItem( int i )
{
	return (CVarListItem*)m_wndTab[ i ]->firstChild();
}

CVarListItem* CVariablesWnd::nextItem( CVarListItem* pitem )
{
	if ( NULL !=  pitem->firstChild() ){
		return (CVarListItem*)pitem->firstChild();
	}
	while ( NULL != pitem ){
		if ( NULL != pitem->nextSibling() ){
			return (CVarListItem*)pitem->nextSibling();
		}
		pitem = (CVarListItem*)pitem->parent();
	}
	return NULL;
}

void CVariablesWnd::Prepare()
{
	for ( int i = 0 ; i < 3 ; ++i ){
		CVarListItem* pitem = firstItem( i );
		while ( NULL != pitem ){
			pitem->m_extra = 0;
			pitem = nextItem( pitem );
		}
	}
}

void CVariablesWnd::AddVar( int i, const char* pcszParent, const char* pcszName, const char* pcszValue )
{
	assert( 0 <= i && i < 3 );

	int	fFound = FALSE;
	CVarListItem* pitem = firstItem( i );
	while ( NULL != pitem ){
		if ( 0 == strcmp( pitem->text( 0 ), pcszParent ) ){
			CVarListItem* pitemParent = pitem;
			CVarListItem* pitemPrev = NULL;
			int	fChildFound = FALSE;
			pitem = (CVarListItem*)pitem->firstChild();
			while ( NULL != pitem ){
				int iComp = strcmp( pitem->text( 0 ), pcszName );
				if ( 0 <= iComp ){
					fChildFound = ( 0 == iComp );
					break;
				}
				pitemPrev = pitem;
				pitem = (CVarListItem*)pitem->nextSibling();
			}
			if ( !fChildFound ){
				if ( NULL == pitemPrev ){
					pitem = new CVarListItem( pcszName, pitemParent );
				}
				else{
					pitem = new CVarListItem( pcszName, pitemParent, pitemPrev );
				}
			}
			pitem->setText( 1, pcszValue );
			pitem->m_extra = 1;			
		}
		else if ( 0 == strcmp( pitem->text( 0 ), pcszName ) && NULL == pitem->parent() &&
			0 == strcmp( pcszParent, "-" ) ){
			pitem->setText( 1, pcszValue );
			pitem->m_extra = 1;
			fFound = TRUE;
		}
		pitem = nextItem( pitem );
	}
	if ( !fFound && 0 == strcmp( pcszParent, "-" ) ){
		pitem = new CVarListItem( pcszName, m_wndTab[ i ] );
		pitem->setText( 1, pcszValue );
		pitem->m_extra = 1;
	}
}

void	CVariablesWnd::Purge()
{
  for ( int i = 0 ; i < 3 ; ++i ){
		CVarListItem* pitem = firstItem( i );
		while ( NULL != pitem ){
			if ( 0 == pitem->m_extra ){
				CVarListItem* pitemToGo = pitem;
				while ( NULL != pitem ){
					if ( NULL != pitem->nextSibling() ){
						pitem = (CVarListItem*)pitem->nextSibling();
						break;
					}
					pitem = (CVarListItem*)pitem->parent();
				}
				delete pitemToGo;
			}
			else{
				pitem = nextItem( pitem );
			}
		}
	}
}
