/***************************************************************************
                          watchwnd.h  -  description
                             -------------------
    begin                : Mon Jun 5 2000
    copyright            : (C) Ives Development Inc, 2000
    email                : Mark_Dixon@teamstudio.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qlistview.h>
#include <qpopupmenu.h>
#include "ctabctl.h"

class CVarListItem;

class CWatchListView : public QListView
{
Q_OBJECT

public:
	CWatchListView( QWidget* parent );

protected:
	void mouseReleaseEvent( QMouseEvent* e );
  void resizeEvent( QResizeEvent* e );
};

class CWatchWnd : public CTabCtl
{
Q_OBJECT

public:
	CWatchWnd( QWidget* parent, const char* name );
	QString	PrepareWatchList();
	void	Purge();
	void	AddVar( const char* pcszParent, const char* pcszName, const char* pcszValue );

signals:
	void notifyWatchListChanged();

protected slots:
	void slotRightClick( QListViewItem* pli );
	void slotAddWatch();
	void slotRemoveWatch();
	void slotChangeValue();

protected:
	CVarListItem*	firstItem( int i );
	CVarListItem*	nextItem( CVarListItem* pitemPrev );

	QListView* 	m_wndTab[ 4 ];
	QPopupMenu*	m_popup;
	QListViewItem*	m_pliCurrent;
};
