<?php
$cfgFile = get_cfg_var( "nexidion_config" );
$cfgFileBak = $cfgFile.".bak";
if ( !$cfgFile ){
  die( "Error: nexidion_config not specified in php.ini" );
}
if ( file_exists( $cfgFile ) && !copy( $cfgFile, $cfgFileBak ) ){
  die ( "Unable to save a backup of the configuration file.  Check file permissions..." );
}
if ( !file_exists( $cfgFile ) && file_exists( $cfgFileBak ) && !unlink( $cfgFileBak ) ){
  die ( "Unable to remove obsolete backup configuration file.  Check file permissions..." );
}
if ( file_exists( $cfgFileBak ) ){
  $fpIn = fopen( $cfgFileBak, "r" );
  if ( !$fpIn ){
    die( "Unable to open backup configuration file.  Check file permissions..." );
  }
  flock( $fpIn, LOCK_EX );  // We're only reading it, but it gives us an exclusive lock for zapping $fpOut
  $fpOut = fopen( $cfgFile, "w" );
  if ( !$fpOut ){
    die( "Unable to open configuration file for writing.  Check file permissions..." );
  }
  while ( $data = fgetcsv( $fpIn, 2048 ) ){
    $num = count( $data );
    if ( 5 == $num && $data[4 ] != $HTTP_GET_VARS[ "ID" ] ){
      fwrite( $fpOut, $data[ 0 ].','.$data[1].','.$data[2].','.$data[3].','.$data[4]."\n" );
    }
  }
  flock( $fpIn, LOCK_UN );
  fclose( $fpIn );
}
else{
  $fpOut = fopen( $cfgFile, "w" );
  if ( !$fpOut ){
    die( "Unable to open configuration file for writing.  Check file permissions..." );
  }
}
fclose( $fpOut );
header( "Location: cfgmain.php" );
exit();
?>
