/***************************************************************************
                          phpprof.h  -  description
                             -------------------
    begin                : Wed Aug 23 2000
    copyright            : (C) Ives Development Inc, 2000
    email                : Mark_Dixon@teamstudio.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _PHPPROF_H
#define _PHPPROF_H

#include <sys/time.h>

#include <zend_extensions.h>

#ifdef PHP_WIN32
#define PHPPROF_API __declspec(dllexport)
#else
#define PHPPROF_API
#endif

//	Globals to hold key times in the execution
extern struct timeval	 gtvActivate;
extern struct timeval  gtvDeactivate;
extern struct timeval  gtvExecuteStart;

//	Utility functions in profstat.c
void InitLineCountData();
void TermLineCountData();
void BumpLineCountData( zend_op* op, struct timeval* ptvLast );

void InitFnCountData();
void TermFnCountData();
void PushFn( const char* pcsz );
void PatchFn( const char* pcsz );
void PopAllFn();
void PopFn();

void DumpStats();

//	Zend interface
PHPPROF_API	void onActivate();
PHPPROF_API	void onDeactivate();
PHPPROF_API	void onStatement(zend_op_array *op_array);
PHPPROF_API	void onFCallBegin(zend_op_array *op_array);
PHPPROF_API	void onFCallEnd(zend_op_array *op_array);

#endif /* _PHPPROF_H */
